package com.bzd.web.controller.hygl.yx;

import com.bzd.common.annotation.Log;
import com.bzd.common.config.dao.PageData;
import com.bzd.common.core.controller.BaseController;
import com.bzd.common.core.domain.AjaxResult;
import com.bzd.common.core.page.TableDataInfo;
import com.bzd.common.enums.BusinessType;
import com.bzd.system.service.PharmaceuticalService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.*;
import com.bzd.system.service.hygl.yx.SHyglHyyxMouldmessageService;

import java.util.List;

/**
*
* 模版文案管理表（模版管理） 前端控制器Controller
* @author LiXiangFei
* @since 2024-10-15
*/
@Controller
@RequestMapping(value = "hygl/shyglhyyxmouldmessage")
public class SHyglHyyxMouldmessageController extends BaseController {

    // 页面跳转前缀
    private String prefix = "hygl/yx";

    @Autowired
    private SHyglHyyxMouldmessageService sHyglHyyxMouldmessageService;

    /**
    * 模版文案管理表（模版管理） 新增页面跳转
    *
    * @return
    */
    @RequiresPermissions("hygl:yx:view")
    @GetMapping("/sHyglHyyxMouldmessageAdd")
    public String add() {
        return prefix + "/SHyglHyyxMouldmessageAdd";
    }

    /**
    * 模版文案管理表（模版管理） 新增
    *
    * @return
    */
    @Log(title = "模版文案管理表（模版管理）新增", businessType = BusinessType.INSERT)
    @PostMapping("/sHyglHyyxMouldmessageAdd")
    @ResponseBody
    public AjaxResult addSave() throws Exception {
        PageData pd = this.getPageData();
        try {
            Integer result = sHyglHyyxMouldmessageService.addSHyglHyyxMouldmessage(pd);
            if (result == 1) {
                return AjaxResult.success("新增成功");
            } else {
                logger.error("Failed to update 表skccrkckreceiptinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("新增失败");
            }
        } catch (Exception e) {
            logger.error("Error occurred while updating 表skccrkckreceiptinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }

    /**
    * 模版文案管理表（模版管理） 查询页面跳转
    *
    * @return
    */
    @RequiresPermissions("hygl:yx:view")
    @GetMapping("/sHyglHyyxMouldmessageView")
    public String shyglhyyxmouldmessageListView() {
        return prefix + "/SHyglHyyxMouldmessageList";
    }

    /**
    * 模版文案管理表（模版管理） 数据查询
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("hygl:yx:sHyglHyyxMouldmessageList")
    @PostMapping("/sHyglHyyxMouldmessageList")
    @ResponseBody
    public TableDataInfo shyglhyyxmouldmessageList() throws Exception {
    PageData pd = this.getPageData();
    startPage();
    List<PageData> pageData = sHyglHyyxMouldmessageService.findSHyglHyyxMouldmessageList(pd);
        return getDataTable(pageData);
    }

    /**
    * 模版文案管理表（模版管理） 数据删除 根据id
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("hygl:yx:remove")
    @Log(title = "模版文案管理表（模版管理）删除", businessType = BusinessType.DELETE)
    @PostMapping("/sHyglHyyxMouldmessageRemove")
    @ResponseBody
    public AjaxResult shyglhyyxmouldmessageRemove() throws Exception {
        PageData pd = this.getPageData();
        Integer integer = sHyglHyyxMouldmessageService.SHyglHyyxMouldmessageRemove(pd);
        return toAjax(integer);
    }

    /**
    * 模版文案管理表（模版管理） 数据修改
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("hygl:yx:edit")
    @GetMapping("/sHyglHyyxMouldmessageEdit/{id}")
    public String shyglhyyxmouldmessageView(@PathVariable("id") Long id, ModelMap mmap) throws Exception {
        PageData pd = this.getPageData();
        pd.put("id", id);
        PageData pageData = sHyglHyyxMouldmessageService.findSHyglHyyxMouldmessageList(pd).get(0);
        mmap.putAll(pageData);
        if(null!=pd.getString("status")){
            return prefix+ "/shyglhyyxmouldmessagePageEdit";
        }
        return prefix+ "/shyglhyyxmouldmessageEdit";
    }

    /**
    * 模版文案管理表（模版管理）保存修改的数据
    */
    @RequiresPermissions("hygl:yx:edit")
    @Log(title = "模版文案管理表（模版管理）修改", businessType = BusinessType.UPDATE)
    @PostMapping("/sHyglHyyxMouldmessageEdit")
    @ResponseBody
    public AjaxResult shyglhyyxmouldmessageEditSave() throws Exception {
        PageData pd = this.getPageData();
        pd.put("up", "up");
        try {
            Integer updateResult = sHyglHyyxMouldmessageService.updateSHyglHyyxMouldmessage(pd);
            if (updateResult == 1) {
                // 成功更新
                return AjaxResult.success("修改成功");
            } else {
                // 更新失败
                logger.error("Failed to update 表shyglhyyxmouldmessage with ID: {}", pd.get("id"));
                return AjaxResult.error("修改失败");
            }
        } catch (Exception e) {
            // 异常处理
            logger.error("Error occurred while updating 表shyglhyyxmouldmessage with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }
}
